/* 
 * $Id: ftp.c,v 1.6 1998/02/11 13:45:05 xach Exp $
 *
 * Anyone feels like it, fix my horrid use of goto.
 *
 * Also, make a standard (non-passive) fallback in case passive doesn't
 * work out.
 * 
 * Thanks :)
 */
#include "config.h"
#include <sys/types.h>
#include <sys/socket.h>
#ifdef HAVE_SYS_FILE_H
# include <sys/file.h>
#endif
#ifdef HAVE_SYS_FCNTL_H
# include <sys/fcntl.h>
#endif
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <pwd.h>
#include <ctype.h>
#include <unistd.h>
#include "protocol.h"
#include "url.h"
#include "ftp.h"
#include "http.h"
#include "snarf.h"
#include "option.h"
#include "misc.h"

#define MAXLEN 4096

union port_t {
  int port_int;
  unsigned char port[1];
};

static int getresponse (int, char *) ;

int ftp_get (struct url u, char *outfile)
{
  struct hostent *host ;
  struct sockaddr_in sa ;
  int s = 0;			/* i like variables like this :P */
  int control, tmp ;
  char send_buf[MAXLEN] ; 
  char line[MAXLEN] ;
  unsigned char *a;
  char *p ;
  int fd = 0;
  int open_flags = O_CREAT | O_WRONLY;
  int response;
  off_t file_offset;
  int passive = 1;
  
  if(getenv("SNARF_PROXY") != NULL){
  	if(!http_get(u, outfile)){
  		return(0);
  	}
  	return(1);
  }

  if(resume && strlen(u.u_file) != 0)
    open_flags |= O_APPEND;
  else
    open_flags |= O_TRUNC;

  /* get the host's IP addr */
  if((host = gethostbyname(u.u_host)) == NULL) {
    my_herror(u.u_host);
    return(0);
  }
  
  if(!(control = tcp_connect(u)))
     return(0);

  /* Login as anonymous, change to reqd. directory and make type binary */

  if (getresponse (control, line) != 220) /* ready for new user */
    return 0 ;
  sprintf (send_buf, "USER %s\r\n", u.u_user) ;
  send (control, send_buf, strlen (send_buf), 0) ;

  response = getresponse(control, line);
  if (response != 331 && response != 230) /* login ok, enter passwd 
					     - or, you're logged in without 
					     further info necessary
					     - zpb */
    return 0 ;
  sprintf (send_buf, "PASS %s\r\n", u.u_pass) ;
  /* some ftp servers may require rest of address too - not done 
     - actually most are pretty flexible, and just warn you if you don't
     put in the whole thing; i've yet to see one that actually requires
     the whole thing
     - zpb */
  send (control, send_buf, strlen (send_buf), 0) ;
  response = getresponse(control, line);
  if (response != 230 && response != 202) /* guest login ok 
					     - or no passwd needed
					     - zpb */
    return 0 ;
  if(u.u_path[1] == '~') { /* user's home dir */
    char *bleh = u.u_path;
    bleh++;
    strcpy(u.u_path, bleh);
  }
  sprintf (send_buf, "CWD %s\r\n", u.u_path) ;
  send (control, send_buf, strlen (send_buf), 0) ;

  if (getresponse (control, line) != 250)
    goto the_end;
  sprintf (send_buf, "TYPE I\r\n") ; /* always use binary */
  send (control, send_buf, strlen (send_buf), 0) ;
  if (getresponse (control, line) != 200) /* type set to I */
    return 0 ;

  /* now for the dirty part - create data connection and suck data from
     server */

  if((s = socket(AF_INET, SOCK_STREAM, 0)) < 0) 
    {
      perror("socket");
      return(0);
    }
  tmp = sizeof (sa) ; 
  /* We use PORT, rather than SO_REUSEADDR. However, you can easily modify
     the code if you want that */
  getsockname (control, (struct sockaddr *)&sa, &tmp) ; 
  sa.sin_port = 0 ; /* let system choose a port */
  if (bind (s, (struct sockaddr *)&sa, sizeof (sa)) < 0)
    {
      perror("bind");
      goto the_end;
    }

  sprintf(send_buf, "PASV\n");
  send(control,send_buf,strlen(send_buf),0);
  
  if ((tmp = getresponse(control, line)) >= 400)
  passive = 0;
  else
  if (tmp != 227)
    goto the_end;

if (passive)
{
   sa.sin_family = AF_INET;

   /* this is real ugly, but I hate sscanf -sean */
   a = (unsigned char *)&sa.sin_addr ;

   /* start looking for digits after the response code -zpb */
   p = line + 4; 

   while(!(isdigit(*p)))
     p++;

   a[0] = atoi(p);
   p = strchr(p,',') + 1;
   a[1] = atoi(p);
   p = strchr(p,',') + 1;
   a[2] = atoi(p);
   p = strchr(p,',') + 1;
   a[3] = atoi(p);
   p = strchr(p,',') + 1;
   a = (unsigned char *)&sa.sin_port ;
   a[0] = atoi(p);
   p = strchr(p,',') + 1;
   a[1] = atoi(p);

   /* sa.sin_port = htons((p[0] << 8)|p[1]); */
   if (connect(s,(struct sockaddr*)&sa, sizeof(sa)) < 0)
     {perror("connects");     return(0);}
}
else
{
sa.sin_family = AF_INET;
sa.sin_port = 0;

if ((s = socket(AF_INET, SOCK_STREAM, 0)) < 0)
{
perror("socket");
return(0);
}

if (bind(s, (struct sockaddr *)&sa, sizeof(sa)) < 0)
{
perror("bind");
return(0);
}

if (listen(s,0) < 0)
{
perror("listen");
return(0);
}

getsockname(s,(struct sockaddr *)&sa,&tmp);

a = (char *)(&sa.sin_addr.s_addr);
p = (char *)(&sa.sin_port);

sprintf(send_buf, "PORT %d,%d,%d,%d,%d,%d\n", a[0],a[1],a[2],a[3],p[0],(unsigned char)p[1]);
send(control, send_buf, strlen(send_buf), 0);
if (getresponse(control, line) != 200)
return(0);
}

   /* get a file descriptor pointing at the right place */
  if(strcmp(outfile, "-") == 0)
    fd = 1;
  else
    if((fd = open(outfile, open_flags, 0644)) < 0) 
      {
	perror(outfile);
	return(0);
      }

  /* if the resume option is set, get the size of the local file and tell
     the ftp server to restart the transfer at that offset in the remote
     file
     - xach */
  if(resume){
    file_offset = getsize(u.u_file);
    sprintf(send_buf, "REST %ld\r\n", (long int)file_offset);
    send(control, send_buf, strlen(send_buf), 0);
    if(getresponse(control, line) != 350) 
      {
	fprintf(stderr, 
		"resume not supported; try again without using -r switch\n");
	goto the_end;
      }
  }

  /* if URL ends in a /, we ask for a directory listing */    
  if (strcmp (u.u_file, ""))
    sprintf (send_buf, "RETR %s\r\n", u.u_file) ;
  else
    sprintf (send_buf, "NLST\r\n") ;

  send (control, send_buf, strlen (send_buf), 0) ;

if (!passive)
  s = accept(s,(struct sockaddr *)&sa,&tmp);

  if ((tmp = getresponse (control, line)) != 150) /* opening connection */
  if(tmp != 125)
    goto the_end;
if (!passive)
getsockname(s, (struct sockaddr *)&sa, &tmp);

dump_data(s, fd); /* suck data from server and dump it to fd */

/*  
    while((tmp = read(data, line, sizeof(line))) > 0){
    write(fd, line, tmp); 
    if(hash)
      fprintf(stderr, "#");
  }
*/
  

  getresponse (control, line) ;

 the_end:
  sprintf (send_buf, "QUIT\r\n") ;
  send (control, send_buf, strlen (send_buf), 0) ;
  getresponse (control, line) ;

  close (fd) ;
  close (control) ;
/*
  close (data) ;
*/
  close (s) ;
  return 1 ;
}


/* Gets replies from server, ignores informational lines, and returns
   reply code */

static int getresponse (int fd, char *line) 
{
  int bytes_read ;

  while ((bytes_read = readline (fd, line)) > 0)
    {
      if (verbose) 
	fprintf (stderr, "%s", line) ;
      if (line[3] != '-' && (isdigit(line[0])))
	                                    /* if it's not some informative 
					       message */
	/* - actually, microsoft ftp servers (and perhaps others) are lame
	   enough to reply with status messages that have a space as the 
	   first letter. stupid! i think. -zpb 
	   whoops...the rfc says you can do that, heh. you have an initial
	   response that starts with a number and a dash, then iwhatever you
	   like, and then a line with the actual status number - zpb */
	break ;
    }
  
  if((line[0] == '5' || line[0] == '4') && ! verbose)
    fprintf(stderr, "%s", line);

  if (bytes_read <= 0) 
    return bytes_read ;
  else
    return atoi (line) ;
}



/*
------------>8--------------------->8------------------------>8------------

							-- Ganesh
						 (ganesh@cse.iitb.ernet.in)
----------------------------------------------------------------------------
"Today for show and tell, I've brought a tiny marvel of nature : a single
snowflake. I think we might all learn a lesson from how this utterly unique
and exquisite crystal turns into an ordinary, boring molecule of water, just
like every other one, when you bring it in the classroom. And now, while the
analogy sinks in, I'll be leaving you drips and going outside."
			-- Calvin and Hobbes, "Homicidal Psycho Jungle Cat"
----------------------------------------------------------------------------
*/
